/*
 * soclib_xcu.c - soclib XCU driver API implementation.
 *
 * Authors  Alain Greiner    (2016)
 *
 * Copyright (c) UPMC Sorbonne Universites
 *
 * This file is part of ALMOS-MKH.
 *
 * ALMOS-MKH.is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.0 of the License.
 *
 * ALMOS-MKH.is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ALMOS-kernel; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include <soclib_xcu.h>
#include <hal_types.h>
#include <core.h>
#include <chdev.h>

#include <hal_apic.h>
#include <hal_internal.h>

extern size_t ioapic_pins;

void soclib_xcu_init(chdev_t *icu, lid_t lid)
{
	size_t i;

	/* disable all IRQs */
	for (i = 0; i < ioapic_pins; i++) {
		hal_ioapic_set_entry(i, IOENTRY_DISABLE);
	}

	x86_panic((char *)__func__);
}

void soclib_xcu_disable_irq( chdev_t  * icu,
                             uint32_t   mask,
                             uint32_t   type,
                             lid_t      lid )
{
	x86_panic((char *)__func__);
}

void soclib_xcu_enable_irq( chdev_t  * icu,
                            uint32_t   mask,
                            uint32_t   type,
                            lid_t      lid )
{
	x86_panic((char *)__func__);
}

void soclib_xcu_get_masks( chdev_t   * icu,
                           lid_t       lid,
                           uint32_t  * hwi_mask,
                           uint32_t  * wti_mask,
                           uint32_t  * pti_mask )
{
	x86_panic((char *)__func__);
}

void soclib_xcu_set_period( chdev_t * icu,
                            uint32_t  index,
                            uint32_t  period )
{
	x86_panic((char *)__func__);
}

uint32_t soclib_xcu_ack_timer( chdev_t * icu,
                               uint32_t  index )
{
	x86_panic((char *)__func__);
	return 0;
}

void soclib_xcu_get_status( chdev_t  * icu,
                            lid_t      lid,
                            uint32_t * hwi_status,
                            uint32_t * wti_status,
                            uint32_t * pti_status )
{
	x86_panic((char *)__func__);
}

void soclib_xcu_send_ipi( xptr_t  icu_xp,
                          lid_t   lid )
{
	x86_panic((char *)__func__);
}

uint32_t * soclib_xcu_wti_ptr( chdev_t  * icu,
                               uint32_t   index )
{
	x86_panic((char *)__func__);
	return NULL;
}
